package com.seeyon.ctp.portal.section;

import com.seeyon.apps.govdoc.manager.GovdocPishiManager;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.common.i18n.ResourceUtil;
import com.seeyon.ctp.common.log.CtpLogFactory;
import com.seeyon.ctp.portal.section.templete.BaseSectionTemplete;
import com.seeyon.ctp.portal.section.templete.MultiRowVariableColumnTemplete;
import com.seeyon.ctp.util.FlipInfo;
import com.seeyon.ctp.util.Strings;
import com.seeyon.v3x.edoc.domain.EdocPishiSummary;
import edu.emory.mathcs.backport.java.util.Arrays;
import org.apache.commons.logging.Log;
import org.apache.tools.ant.util.DateUtils;

import java.text.ParseException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class LeaderPiShiDoneSection  extends  BaseSectionImpl {

    private static final Log LOGGER = CtpLogFactory.getLog(LeaderPiShiPendingSection.class);
    private GovdocPishiManager govdocPishiManager;

    public void setGovdocPishiManager(GovdocPishiManager govdocPishiManager) {
        this.govdocPishiManager = govdocPishiManager;
    }

    @Override
    public String getId() {
        return "leaderPiShiDoneSection";
    }

    @Override
    public String getName(Map<String, String> preference) {
        // 栏目显示的名字，必须实现国际化，在栏目属性的“columnsName”中存储
        String name = preference.get("columnsName");
        if (Strings.isBlank(name)) {
            return name = ResourceUtil.getString("govdoc.leaderPiShi.done.label");
        } else {
            return name;
        }
    }

    @Override
    public Integer getTotal(Map<String, String> preference) {
        return null;
    }

    @Override
    public String getIcon() {
        return null;
    }

    @Override
    public BaseSectionTemplete projection(Map<String, String> preference) {
        MultiRowVariableColumnTemplete c = new MultiRowVariableColumnTemplete();
        FlipInfo flipInfo = new FlipInfo();
        // 显示行数
        String count = preference.get("count");
        //默认行数
        int coun = 8;
        if (Strings.isNotBlank(count)) {
            coun = Integer.parseInt(count);
        }
        coun= c.getPageSize(preference)[0];
        flipInfo.setSize(coun);
        Map<String, String> map = new HashMap<String, String>();
        map.put("leaderPishiType","done");
        try{
            if (preference.get("sender_value") != null && !"".equals(preference.get("sender_value"))) {// 发起人
                String[] senders = preference.get("sender_value").toString().split(",");
                String senderId = "";
                for (String sender : senders) {
                    senderId += sender.split("\\|")[1] + ",";
                }
                map.put("senderId", senderId.substring(0, senderId.length() - 1));
            }
            if (preference.get("sources_importLevel_value") != null
                    && !"".equals(preference.get("sources_importLevel_value"))) {// 紧急程度
                map.put("importantLevel", preference.get("sources_importLevel_value"));
            }
            if (preference.get("sources_Policy_value") != null && !"".equals(preference.get("sources_Policy_value"))) {// 节点权限
                String[] policys = preference.get("sources_Policy_value").toString().split(",");
                String policyName = "";
                for (String policy : policys) {
                    policyName += policy.split("___")[1] + ",";
                }
                map.put("nodePolicy", policyName.substring(0, policyName.length() - 1));
            }
            if (preference.get("sources_relation_select") != null
                    && !"".equals(preference.get("sources_relation_select"))) {// and或or
                if ("1".equals(preference.get("sources_relation_select"))) {
                    map.put("andRelation", "1");
                } else {
                    map.put("andRelation", "0");
                }
            }
            if (preference.get("sources_templete_pending_value") != null
                    && !"".equals(preference.get("sources_templete_pending_value"))) {// 模板
                map.put("template", preference.get("sources_templete_pending_value"));
            }
            if (preference.get("sources_track_catagory_value") != null
                    && !"".equals(preference.get("sources_track_catagory_value"))) {// 节点权限
                String app = preference.get("sources_track_catagory_value").toString().replace("catagory_coll", "1")
                        .replace("catagory_edoc", "4").replace("catagory_collOrFormTemplete", "1,2");
                map.put("catagoryApp", app);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        try {
            flipInfo = govdocPishiManager.getlistPishiList(flipInfo,map);
            List<EdocPishiSummary> curData = flipInfo.getData();
            c = this.getTemplete(c,curData,preference);
            c.setDataNum(coun);
            c.addBottomButton(BaseSectionTemplete.BOTTOM_BUTTON_LABEL_MORE,"/govdoc/govdoc.do?method=leaderPishiList&leaderPishi=done&listType=listDoneAll");
            return  c;
        } catch (BusinessException e) {
            e.printStackTrace();
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return null;
    }
    private MultiRowVariableColumnTemplete getTemplete(MultiRowVariableColumnTemplete c,List<EdocPishiSummary> curData, Map<String, String> preference) {
        String rowList = preference.get("rowList");
        if(Strings.isBlank(rowList)){
            rowList = "subject,receiveTime,edocMark,currentNodesInfo";
        }
        String [] rowStr = rowList.split(",");
        List<String> list = Arrays.asList(rowStr);
        //判断是否选择‘标题’
        boolean isSubject = list.contains("subject");
        //判断是否选择‘发起时间’
        boolean isReceiveTime = list.contains("receiveTime");
        //判断是否选择‘公文文号’
        boolean isEdocMark = list.contains("edocMark");
        //判断是否选择‘内部文号’
        boolean isSerialMark = list.contains("serialMark");
        //判断是否选择‘分类’
        boolean isCategory = list.contains("category");
        //判断是否选择‘当前待办人’
        boolean isCurrentNodesInfo = list.contains("currentNodesInfo");
        for (int i=0 ; i<curData.size() ; i++){
            MultiRowVariableColumnTemplete.Row row = c.addRow();
            //标题
            MultiRowVariableColumnTemplete.Cell subjectCell = null;
            //发起时间
            MultiRowVariableColumnTemplete.Cell receiveTimeCell= null;
            //公文文号
            MultiRowVariableColumnTemplete.Cell edocMarkCell = null;
            //内部文号
            MultiRowVariableColumnTemplete.Cell serialMarkCell = null;
            //当前待办人
            MultiRowVariableColumnTemplete.Cell currentNodesInfoCell=null;
            //分类
            MultiRowVariableColumnTemplete.Cell categoryCell=null;

            if(isSubject){
                subjectCell = row.addCell();
            }
            if(isReceiveTime){
                receiveTimeCell = row.addCell();
            }
            if(isEdocMark){
                edocMarkCell = row.addCell();
            }
            if(isSerialMark){
                serialMarkCell = row.addCell();
            }
            if(isCurrentNodesInfo){
                currentNodesInfoCell = row.addCell();
            }
            if(isCategory){
                categoryCell = row.addCell();
            }
            if(subjectCell != null){
                StringBuilder url = new StringBuilder();
                url.append("/govdoc/govdoc.do?method=summary&leaderPishiType=2&affairId=");
                url.append(curData.get(i).getAffairId());
                url.append("&openFrom=listDoneing");
                subjectCell.setLinkURL(url.toString());
                subjectCell.setAlt(curData.get(i).getSubject());
                subjectCell.setCellContent(curData.get(i).getSubject());
                //添加附件图标
                if(curData.get(i).getHasAtt()){
                    subjectCell.addExtClasses("ico16 vp-attachment");
                }
                //添加正文图标
                String bodyType = curData.get(i).getBodyType();
                if(Strings.isNotBlank(bodyType) && !"10".equals(bodyType) && !"30".equals(bodyType)) {
                    String bodyTypeClass = convertPortalBodyType(bodyType);
                    if (!"meeting_video_16".equals(bodyTypeClass)) {
                        bodyTypeClass = "office" + bodyTypeClass;
                    }
                    if(!"html_16".equals(bodyTypeClass)) {
                        subjectCell.addExtClasses("ico16 "+bodyTypeClass);
                    }
                }
                //添加超期图标
                if(curData.get(i).getCoverTime()){
                    subjectCell.addExtIcon("/common/images/overTime.gif");
                }else{
                    if(!ResourceUtil.getString("collaboration.project.nothing.label").equals(curData.get(i).getAffairDeadLineName())){
                        if(curData.get(i).getAffairIsCoverTime()){
                            subjectCell.addExtClasses("ico16 extended_red_16");
                        }else{
                            subjectCell.addExtClasses("ico16 extended_blue_16");
                        }
                    }
                }
                subjectCell.setCellContent(curData.get(i).getSubject().replaceAll("\\r\\n", ""));
            }
            if(receiveTimeCell != null){
                receiveTimeCell.setCellContent(DateUtils.format(curData.get(i).getCreateTime(), "yyyy-MM-dd hh:mm"));
                receiveTimeCell.setAlt(DateUtils.format(curData.get(i).getCreateTime(), "yyyy-MM-dd hh:mm"));
                receiveTimeCell.setCellContentHTML(DateUtils.format(curData.get(i).getCreateTime(), "yyyy-MM-dd hh:mm"));
            }
            if(edocMarkCell != null){
                edocMarkCell.setCellContent(curData.get(i).getDocMark());
                edocMarkCell.setAlt(curData.get(i).getDocMark());
                edocMarkCell.setCellContentHTML(curData.get(i).getDocMark()==null?"":curData.get(i).getDocMark());
            }
            if(serialMarkCell != null){
                serialMarkCell.setCellContent(curData.get(i).getSerialNo());
                serialMarkCell.setAlt(curData.get(i).getSerialNo());
                serialMarkCell.setCellContentHTML(curData.get(i).getSerialNo()==null?"":curData.get(i).getSerialNo());
            }
            if(currentNodesInfoCell != null){
                currentNodesInfoCell.setCellContent(curData.get(i).getCurrentNodesInfo());
                currentNodesInfoCell.setAlt(curData.get(i).getCurrentNodesInfo());
                currentNodesInfoCell.setCellContentHTML(curData.get(i).getCurrentNodesInfo());
            }
            if(categoryCell!=null){
                String content=getCategory4SubApp(curData.get(i).getSubApp());
                categoryCell.setCellContent(content);
                categoryCell.setAlt(content);
                categoryCell.setCellContentHTML(content);
            }
        }
        return c;
    }
    
    private String getCategory4SubApp(Integer subapp){
        if(1==subapp){
            return "发文";
        }else if(2==subapp||4==subapp){
            return "收文";
        }else if(3==subapp){
            return "签报";
        }
        return "";
    }
    private String convertPortalBodyType(String bodyType) {
        String bodyTypeClass = "html_16";
        if("FORM".equals(bodyType) || "20".equals(bodyType)) {
            bodyTypeClass = "form_text_16";
        } else if("TEXT".equals(bodyType) || "30".equals(bodyType)) {
            bodyTypeClass = "txt_16";
        } else if("OfficeWord".equals(bodyType) || "41".equals(bodyType)) {
            bodyTypeClass = "doc_16";
        } else if("OfficeExcel".equals(bodyType) || "42".equals(bodyType)) {
            bodyTypeClass = "xls_16";
        } else if("WpsWord".equals(bodyType) || "43".equals(bodyType)) {
            bodyTypeClass = "wps_16";
        } else if("WpsExcel".equals(bodyType) || "44".equals(bodyType)) {
            bodyTypeClass = "xls2_16";
        } else if("Pdf".equals(bodyType) || "45".equals(bodyType)) {
            bodyTypeClass = "pdf_16";
        } else if("Ofd".equals(bodyType) || "46".equals(bodyType)) {
            bodyTypeClass = "ofd_16";
        } else if("videoConf".equals(bodyType)) {
            bodyTypeClass = "meeting_video_16";
        }
        return bodyTypeClass;
    }
	@Override
	public String getResolveFunction(Map<String, String> preference) {
		return MultiRowVariableColumnTemplete.RESOLVE_FUNCTION;
	}
}
